unit GUIFABListUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  //
  lmdstdcS, lmdctrl, lmdextcS, lmdcctrl, Menus, ActnList, ImgList, lmdcompo,
  lmdclass, lmddlgS, VersInfo, ComCtrls, ToolWin, LMDCustomComponent,
  LMDContainerComponent, LMDBaseDialog, LMDAboutDlg, LMDCustomSimpleLabel,
  LMDSimpleLabel, LMDControl, LMDBaseControl, LMDBaseGraphicControl,
  LMDBaseLabel, LMDInformationLabel, LMDCustomControl, LMDCustomPanel,
  LMDCustomBevelPanel, LMDCustomStatusBar, LMDStatusBar, StdActns,
  ExtActns, ActnMan, Grids, DBGrids, RXDBCtrl, CheckRxDBGrid, DB, DBTables,
  LMDCustomComboBox, LMDDriveComboBox, LMDFileOpenEdit, LMDBaseEdit,
  LMDCustomEdit, LMDCustomBrowseEdit, LMDBrowseEdit, ToolEdit, Mask,
  CheckLst, ProChLst, RxCombos, RRGMPrintDef, LMDDrawEdge, BorBtns,
  LMDCustomColorComboBox, LMDColorComboBox, RXCtrls, RXSpin, Printers,
  ActnCtrls, LMDHookComponent, LMDFMDrop;

type
  TfrmMain = class(TForm)
    statMain: TLMDStatusBar;
    statMainDateTime: TLMDInformationLabel;
    statMainVariable: TLMDInformationLabel;
    statMainHint: TLMDSimpleLabel;
    pnlTopLeft: TPanel;
    statMainInfo: TLMDStatusBar;
    dlgAbout: TLMDAboutDlg;
    VersInfo: TVersInfo;
    pnlBottom: TPanel;
    SplitterBottom: TSplitter;
    HotImages: TImageList;
    actionMain: TActionManager;
    actOpen: TFileOpen;
    actExit: TFileExit;
    actAbout: TAction;
    statMainInfoMessage2: TLMDSimpleLabel;
    statMainInfoMessage: TLMDSimpleLabel;
    listFiles: TProCheckListBox;
    GroupBox1: TGroupBox;
    ckCourier: TBorRadio;
    ckLinePrinter: TBorRadio;
    PrinterDefinition: TPrinterDefinition;
    GroupBox2: TGroupBox;
    ckLandscape: TBorCheck;
    ckHeaders: TBorCheck;
    ckLineNumbers: TBorCheck;
    ckPrintBars: TBorCheck;
    spinBarHeight: TRxSpinEdit;
    RxLabel1: TRxLabel;
    actDelEntry: TAction;
    actClearList: TAction;
    GroupBox3: TGroupBox;
    ck6lpi: TBorRadio;
    ck8lpi: TBorRadio;
    GroupBox4: TGroupBox;
    ckibm: TBorRadio;
    cknoibm: TBorRadio;
    RxLabel2: TRxLabel;
    ckCompressed: TBorCheck;
    actPrint: TAction;
    CoolBar1: TCoolBar;
    ActionToolBar1: TActionToolBar;
    RxLabel3: TRxLabel;
    LMDFMDrop: TLMDFMDrop;
    procedure statMainVariableClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure actAboutExecute(Sender: TObject);
    procedure actOpenAccept(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure actDelEntryExecute(Sender: TObject);
    procedure actClearListExecute(Sender: TObject);
    procedure PrinterDefinitionPrinterChange(Sender: TObject);
    procedure dlgAboutCustomClick(Sender: TObject);
    procedure ckPrintBarsClick(Sender: TObject);
    procedure FABListProcess(aFileName: string);
    procedure ShadeIt;
    procedure DirectPrint(s: String);
    procedure PageSettings(Sender: TObject);
    procedure actPrintExecute(Sender: TObject);
    procedure LMDFMDropFMDragDrop(Sender: TObject; fcount, x, y: Integer;
      FileList: TStrings);
  private
    BuildString: string;
    { Private declarations }
  public
    procedure DisplayHint(Sender: TObject);
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses UPrnRaw;

var BarHeight: integer;
    pnum: integer;
    pnumstr: string;
    lnum: integer;
    lnumstr: string;
    header: string;
    stamp: string;
    wid: integer;
    lpi: integer;
    lengthinhalfinches, widthinhalfinches: integer;
    linedots, wdots, leng, wd, ln, newln, startwid: integer;
    ch: char;
    F: Textfile;
    work: string;
    devnum: integer; devname: string;

const
  es: char = #27;
  cr: char = #13;
  lf: char = #10;
  ff: char = #12;
  //

{$R *.DFM}

procedure TfrmMain.statMainVariableClick(Sender: TObject);
begin
  statMainVariable.Visible := False;
  case Ord(statMainVariable.Info) of
  0: statMainVariable.Info := Succ(statMainVariable.Info);
  1: statMainVariable.Info := Succ(statMainVariable.Info);
  2..14:  while (Ord(statMainVariable.Info) <> 15) do
    statMainVariable.Info := Succ(statMainVariable.Info);
  15..24: while (Ord(statMainVariable.Info) <> 25) do
    statMainVariable.Info := Succ(statMainVariable.Info);
  25..39: while (Ord(statMainVariable.Info) <> 40) do
    statMainVariable.Info := Succ(statMainVariable.Info);
  40: while (Ord(statMainVariable.Info) <> 0) do
    statMainVariable.Info := Pred(statMainVariable.Info);
  end;
  if Ord(statMainVariable.Info) = 40 then
        statMainVariable.UseStandardCaption := false
  else
        statMainVariable.UseStandardCaption := true;
  statMainVariable.Visible := True;
end;


procedure TfrmMain.FormCreate(Sender: TObject);
var found: integer;
  exerec: TSearchRec;
begin
  found:=findfirst(application.exename,faAnyFile,exerec);
  versinfo.FileName := exerec.Name;
  Buildstring :='Build ' + versinfo.ModuleVersionNumber
   + ': ' + FormatDateTime('dddd, mmmm d, yyyy '
   + '"at" h:mm am/pm', filedatetodatetime(exerec.Time));
  FindClose(exerec);
  //
  //
  statMainInfoMessage.Caption := BuildString;
  statMainInfoMessage.font.Color := clPurple;
  statMainInfoMessage2.Caption := '';
  statMainInfoMessage2.font.Color := clRed;
  dlgAbout.CaptionTitle := Buildstring;
  dlgAbout.Appname := versinfo.ProductName;
  dlgAbout.Copyright := versinfo.Copyright;
  dlgAbout.Description := versinfo.Comments;
  dlgAbout.Version := versinfo.ModuleVersionNumber;
  dlgAbout.EMail := 'rgm@fabbnet.net';
  dlgAbout.Jump := 'http://www.fabbnet.net/delphi.htm';
  //
  //statMainHint.Caption := BuildString;
  //
  Application.OnHint := DisplayHint; Application.OnHint := DisplayHint;
end;

procedure TfrmMain.DisplayHint(Sender: TObject);
begin
  statMainHint.Caption := GetLongHint(Application.Hint);
end;

procedure TfrmMain.actAboutExecute(Sender: TObject);
begin
  dlgAbout.CaptionTitle :=
    Buildstring;
  dlgAbout.ExecuteEnh(frmMain);
end;

//
//  Application Specific
//

procedure TfrmMain.FormActivate(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  PrinterDefinition.UseWinDefaults := [DefaultPrinter];
  PrinterDefinition.UseWinDefaults := [];
  PageSettings(Self);    // to set defaults;
  Screen.Cursor := crDefault;
end;

procedure TfrmMain.DirectPrint(s: String);
begin
  WriteData(pchar(S), length(S));
end;

procedure TfrmMain.ShadeIt;
var stepval, vert: integer;                             // add local variables
begin
 work := es + '&f1Y'; Directprint(work);                //specify macro ID
 work := es + '&f0X'; Directprint(work);                //start macro def
 work := es + '&f0S'; Directprint(work);                //store cursor position
 //
 stepval := linedots * spinBarHeight.asInteger * 2;
 //
 //  need to make first bar manually since the for..to..step
 //     syntax not supported in pascal
 //
 vert := 0;
 work := es + '&a' + InttoStr(vert) + 'V'; Directprint(work);  //position cursor
 work := es + '*c' + InttoStr(wdots) + 'A'; Directprint(work); //set shade width
 work := es + '*c' + InttoStr(linedots * spinBarHeight.asInteger) + 'V';//height
 Directprint(work);
 work := es + '*c10G'; Directprint(work);                      //set shade degree
 work := es + '*c2P'; Directprint(work);
 //
 for vert := linedots * spinBarHeight.asInteger to (linedots * leng - 1) do
  if ((vert mod stepval) = 0) then                        // substitute for STEP
   begin
   work := es + '&a' + InttoStr(vert) + 'V'; Directprint(work);
   work := es + '*c' + InttoStr(wdots) + 'A'; Directprint(work);
   work := es + '*c' + InttoStr(linedots * spinBarHeight.asInteger) + 'V';
   Directprint(work);
   work := es + '*c10G'; Directprint(work);
   work := es + '*c2P'; Directprint(work);
   end;
 // NEXT                                                //print shade
 work := es + '&f1S'; Directprint(work);                //restore cursor position
 work := es + '&f1X'; Directprint(work);                //end macro definition
 //                                                     //enable macro as overlay
 work := es + '&f4X'; Directprint(work);                // always executes AFTER
end;                                                    // rest of page

procedure TfrmMain.FABListProcess(aFileName: string);
  //
  //  Local functions
  //
  function MakeElip(APath: string): string;
  // Makes an elipsis in middle of long path string
  var i: integer;
     send, sbegin: string;
  const maxlength: integer = 30;
  begin
    if POS('\',Apath) =0 then result:=''
    else if length(Apath) < maxlength then result := APath
    else begin
      i:=length(Apath)- 1;
      while copy(Apath,i,1) <> '\' do dec(i);
      send:=copy(Apath,i,length(apath) - i + 1);
      sbegin:=copy(Apath, 1, (maxlength - 2) - length(send) - 3);
      result :=sbegin + '...' + send;
      end;
  end;

  procedure Newpage;
  var factor: integer;
  begin
   if not ckLandscape.checked then factor := 1 else factor := 0;
   pnum := pnum + 1;
   pnumstr := inttostr(pnum);
   pnumstr := 'Page ' + pnumstr;
   insert(pnumstr, header, wid - length(pnumstr) + factor);
   //
  end;
  //
  procedure NewLNum;
  begin
   lnum := lnum + 1;
   lnumstr := inttostr(lnum);
   lnumstr := StringofChar(#32, 6 - Length(lnumstr)) + #32 + lnumstr + ': ';
  end;

begin
  linedots := 720 div lpi;                       //number of decipoints/per/line
  leng := (lengthinhalfinches * lpi) div 2;      //number of lines per page
  wdots := (300 * widthinhalfinches) div 2;      //shade width in dots (@300 dpi)

  StartJob(printer.Printers[devnum],'FABPrint Job');
  //Printer.BeginDoc;
  //
  //start with reset
  //
  work := es + 'E'; Directprint(work);
  //
  //set landscape if required
  //
  if ckLandscape.checked then work := es + '&l1O'; DirectPrint(work);
  //
  //set lpi
  //
  work := es + '&l' + inttostr(lpi) + 'D'; DirectPrint(work);
  //
  //  lineprinter font settings
  //
  if ckLineprinter.checked then
    if ckNoIbm.checked then
      if ckCompressed.Checked then
        //lineprinter hproman 16.66 cpi
        work := es + '(8U' + es + '(s0p16.67h8.5v0s0b0T'
       else
        //lineprinter hproman 10 cpi
        work := es + '(8U' + es + '(s0p10h8.5v0s0b0T'
    else
      if ckCompressed.Checked then
        //lineprinter ibm 16.66 cpi
        work := es + '(10U' + es + '(s0p16.67h8.5v0s0b0T'
       else
        //lineprinter ibm 10 cpi
        work := es + '(10U' + es + '(s0p10h8.5v0s0b0T'
   //
   // courier is default
   //
   else
    if ckNoIbm.checked then
      if ckCompressed.Checked then
         //courier hproman 16.66 cpi
        work := es + '(8U' + es + '(s0p16.67H'
       else
         //courier hproman 10 cpi
        work := es + '(8U'
    else
      if ckCompressed.Checked then
         //courier ibm 16.66 cpi
        work := es + '(10U' + es + '(s0p16.67H'
       else
         //courier ibm 10 cpi
        work := es + '(10U';
  //
  DirectPrint(work);
  //
  //start build of  header line
  //
  header := StringofChar(#32, wid);
  //
  //  uses make elipsis for aFileName
  //
  insert('  File: ' + MakeElip(aFileName), header, 1);
  stamp := formatdatetime('dddd, mmmm d, yyyy" at "h:mm AM/PM', Now);
  insert(stamp, header, (wid div 2) - (length(stamp) div 2));
  //
  //create shading macro and invoke as overlay
  //
  ShadeIt;
  //
  //increment page & line numbers to '1'
  //
  NewPage; NewLnum;
  //
  AssignFile(F, aFileName);
  Reset(F);
  //
  work := header + cr + lf; DirectPrint(work);     //print header line
  work := cr + lf; DirectPrint(work);              //skip a line
  work := lnumstr; DirectPrint(work);              //print first line number
  wd := startwid; ln := 3; newln := 0;             //reset page & width counters
                                                   //    and new line cue
  pnum := 0; lnum := 0;         //reset line and page numbers
  //
  //        main loop reads and prints input file one character at a time
  //
  while not EOF(F) do
  begin
  Read(F, ch);
  //GET 1, , ch
  if newln = 1 then
     begin                                //if line counter has been tripped
     if ln > leng then                    //see if we need to start
       begin                              //a new physical page
       NewPage;                                      //advance the page number
       work := header + cr + lf; DirectPrint(work);  //print header on the new page
       work := cr + lf; DirectPrint(work);           //skip a line
       ln := 3                                       //and reset the lines counter
       end;
     work := lnumstr; DirectPrint(work);             //print next line number
     wd := startwid; newln := 0;                     //reset width counter
     end;                                            //and new line cue
  //
  if ch = cr then                         //if byte is carriage return
     begin                                //we assume end of line
     Read(F, ch);                         //so we get the matching line feed
     //  GET #1, , ch
     ln := ln + 1;                        //advance page counter
     newln := 1;                          //and turnon newline cue
     NewLnum;                             //and advance the line number
     work := cr + lf; DirectPrint(work);  //and print the cr and lf
     end
  //
  else if ch = ff then
     begin                                //if the byte is a literal form feed
     ln := 1;                             //reset the page line counter
     newln := 1;                          //turn on the newline cue
     NewLnum;                             //advance the line number counter
     work := ff; DirectPrint(work);       //and print literal form feed
     end
  //
  else                                    //in all other cases
     begin                                //we print the character
     work := ch; DirectPrint(work);
     wd := wd + 1;                        //advance the line width counter
     if wd = wid then                     //if we're at the end of the line
       begin
       work := cr + lf; DirectPrint(work);//print the cr and lf
       ln := ln + 1;                      //and advance the lines counter
       if ln > leng then                  //if we're at the end
         begin                            //of the page
         Shadeit;
         NewPage;                                 //advance the page number
         work := header + cr + lf;
         DirectPrint(work);                       //print header on the new page
         work := cr + lf; DirectPrint(work);      //skip a line
         ln := 3;                                 //and reset lines counter
         work := StringofChar(#32, startwid + 4); //create blanks where the
                                                  //line number would be
         DirectPrint(work);                       //print the blanks
         wd := startwid + 5;                      //indent the width counter
         end;
                                                  //otherwise we just set the
       work := StringofChar(#32,startwid + 4);    //blanks where the
                                                  //line number would be
       DirectPrint(work);                         //print the blanks
       wd := startwid + 5;                        //indent the width counter
       end;
     end;
  // LOOP
  end; //while    end-of-loop = end-of-file
  //
  CloseFile(F);                                    //new rules
  Shadeit;                                         //always shade last page
  EndPage;                                         // neatness
  EndJob;                                          // counts
  //
  //Printer.EndDoc;
end;

procedure TfrmMain.PageSettings(Sender: TObject);
begin
    if not ckCompressed.checked then
      ckCourier.checked := true;
    //
    if (ckCompressed.checked
       and (not ckLandscape.checked)) then begin       //
           wid := 133;                                 // original comments
           lengthinhalfinches := 20;                   //
           widthinhalfinches := 16;
           end                                         //this is a brute force
    else if ckCompressed.checked
       and cklandscape.checked then begin              //method of setting
           wid := 176;                                 //other print parameters
           lengthinhalfinches := 15;                   //using half inches to
           widthinhalfinches := 21;                    //allow legal results
           end                                         //since PDQ doesn//t allow
                                                       //floating point and so
    else if ((not ckCompressed.checked)
      and (not cklandscape.checked)) then begin        //half-inches are verboten
           wid := 80;                                  //and adjustimg a few max
           lengthinhalfinches := 20;                   //parameters to compensate
           widthinhalfinches := 16;                    //for the integer divisions
           end                                         //especially in the
                                                       //landscape width, which is
    else if ((not ckCompressed.checked)
      and (not cklandscape.checked)) then begin        //one less than the laser
           wid := 105;                                 //will print but is the same
           lengthinhalfinches := 15;                   //as the shading width
           widthinhalfinches := 21;
           end;
    //
    if ck6lpi.Checked then lpi := 6
      else lpi := 8;
    //
end;

procedure TfrmMain.actOpenAccept(Sender: TObject);
var i: integer;
begin
  for i := 0 to ActOpen.Dialog.Files.Count - 1 do begin
    listFiles.Items.Add(ActOpen.Dialog.Files[i]);
    listfiles.Checked[listfiles.Items.count - 1] := true;
    end;
end;

procedure TfrmMain.LMDFMDropFMDragDrop(Sender: TObject; fcount, x,
  y: Integer; FileList: TStrings);
var i: integer;
begin
  for i := 0 to Filelist.Count - 1 do begin
    listFiles.Items.Add(FileList[i]);
    listfiles.Checked[listfiles.Items.count - 1] := true;
    end;
end;

procedure TfrmMain.actDelEntryExecute(Sender: TObject);
begin
  listFiles.DeleteSelected;
end;

procedure TfrmMain.actClearListExecute(Sender: TObject);
begin
  listFiles.Clear;
end;

procedure TfrmMain.PrinterDefinitionPrinterChange(Sender: TObject);
begin
  devnum := PrinterDefinition.ItemIndex;
  devname := PrinterDefinition.PrinterName;
  statMainInfoMessage.caption := '  Printing on '
   + PrinterDefinition.PrinterName + ' printer #' + inttostr(devnum);
end;

procedure TfrmMain.ckPrintBarsClick(Sender: TObject);
begin
  spinBarHeight.Enabled := ckPrintBars.Checked;
end;

procedure TfrmMain.actPrintExecute(Sender: TObject);
var i: integer;
begin
  if listFiles.count = 0 then begin
    ShowMessage('No files to print!?!');
    exit;
    end
  //
  else begin
    for i := 0 to listFIles.count -1 do
      if listFiles.Checked[i] then begin
        statMainInfoMessage2.Caption := 'Printing '
          + extractfilename(listFiles.Items[i]);
        try
        FABListProcess(listFiles.Items[i]);
        finally
        statMainInfoMessage2.Caption := '';
        end;
        end;
    end;
end;

procedure TfrmMain.dlgAboutCustomClick(Sender: TObject);
var m: string;
begin
  m := 'An archaeological project of the Fine-Arts Bluesband && Poetry Press.'
  + cr + lf
  + cr + lf
  + 'In this version the Header and Line Number options are for show only.'
  + cr + lf + 'They both will always print.'
  + cr + lf
  + cr + lf
  + 'You can drag files to the print window, if you want. Try to select only'
  + cr + lf + 'true ASCII files.'
  + cr + lf
  + cr + lf
  + 'Any printer or file error at any point will abort printing of'
  + cr + lf + 'the entire list.'
  + cr + lf
  + cr + lf
  + 'If you select an unsupported or phantom printer (like PDF Writer) then'
  + cr + lf + 'the results may surprise you (usually will output to previously'
  + cr + lf + 'selected real printer.)';
  //
  ShowMessage(m);
end;

end.
